routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@welcome')->name('welcome');

Auth::routes();

Route::resource('/schedules', 'ScheduleController');

Route::middleware('auth')->group(function () {
    Route::get('/user_schedules', 'ScheduleController@userSchedule')->name('schedules.user_schedules')->middleware('isContributor');

    Route::get('/bookings/{schedule}', 'BookingController@create')->name('schedules.book_schedule');
    Route::post('/bookings', 'BookingController@store')->name('schedules.store_book');
    Route::get('/bookings', 'BookingController@index')->name('bookings.index');
});

app/Models/Schedule.php
<?php

namespace App\Models;

use App\Actions\ScheduleStatus;
use App\Traits\UuidTrait;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\Relations\HasOne;
use Illuminate\Database\Eloquent\Relations\MorphTo;
use Illuminate\Database\Eloquent\SoftDeletes;

/**
 * Class User
 * @package App\Models

 * @property BelongsTo contributor
 * @property HasOne booking
 * @property boolean isAvailable
 * @property boolean isBooked
 * @property boolean isOngoing
 * @property boolean isExpire
 * @property boolean isEnd
 *
 * @property string title
 * @property string status
 */

class Schedule extends Model
{
    use UuidTrait , SoftDeletes;

    protected $guarded = [];

    protected $casts = [
        'start_date' => 'datetime',
        'end_date' => 'datetime',
    ];

    /**
     * @return BelongsTo
     */
    public function contributor(){
        return $this->belongsTo(Contributor::class);
    }

    /**
     * @return HasOne
     */
    public function booking(){
        return $this->hasOne(Booking::class);
    }


    public function isAvailable(){
        return $this->status == ScheduleStatus::AVAILABLE;
    }

    public function isBooked(){
        return $this->status == ScheduleStatus::BOOKED;
    }

    public function isOngoing(){
        return $this->status == ScheduleStatus::ONGOING;
    }

    public function isExpire(){
        return $this->status == ScheduleStatus::EXPIRE;
    }

    public function isEnd(){
        return $this->status == ScheduleStatus::END;
    }

}

app/Http/Controllers/ScheduleController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\CreateScheduleRequest;
use App\Http\Requests\UpdateScheduleRequest;
use App\Jobs\StartSchedule;
use App\Models\Schedule;
use App\Repositories\ScheduleRepository;
use Carbon\Carbon;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Redirect;

class ScheduleController extends Controller
{
    /**
     * @var ScheduleRepository
     */
    private $scheduleRepository;

    /**
     * ScheduleController constructor.
     * @param ScheduleRepository $scheduleRepository
     */
    public function __construct(ScheduleRepository $scheduleRepository)
    {
        $this->scheduleRepository = $scheduleRepository;
    }

    /**
     * Display a listing of the resource.
     *
     * @return void
     */
    public function index()
    {
        //
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     * @throws AuthorizationException
     */
    public function create()
    {
        $this->authorize('create',Schedule::class);

        return view('schedules.create');
    }

    /**
     * Store a newly created Schedule to database.
     * add this schedule to queue , dispatch in start_date
     *
     * @param CreateScheduleRequest $request
     * @return RedirectResponse
     */
    public function store(CreateScheduleRequest $request)
    {
        $input = $request->all();
        $input['end_date'] = Carbon::parse($input['start_date'])->addHour();
        $schedule = $this->scheduleRepository->create($input);

        StartSchedule::dispatch($schedule)->delay(Carbon::parse($schedule->start_date));

        return Redirect::route('schedules.user_schedules')->with('status', 'Done');
    }

    /**
     * Display the specified resource.
     *
     * @param Schedule $schedule
     * @return void
     */
    public function show(Schedule $schedule)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.c
     *
     * @param Schedule $schedule
     * @return Factory|\Illuminate\View\View
     * @throws AuthorizationException
     */
    public function edit(Schedule $schedule)
    {
        $this->authorize('update',$schedule);
        return view('schedules.edit',compact('schedule'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param UpdateScheduleRequest $request
     * @param Schedule $schedule
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function update(UpdateScheduleRequest $request, Schedule $schedule)
    {
        $this->authorize('update',$schedule);
        $input = $request->all();
        $input['end_date'] = Carbon::parse($input['start_date'])->addHour();
        $this->scheduleRepository->update($input , $schedule);

        StartSchedule::dispatch($schedule)->delay(Carbon::parse($schedule->start_date));

        return Redirect::route('schedules.user_schedules')->with('status', 'Done');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Schedule $schedule
     * @return RedirectResponse
     * @throws \Exception
     */
    public function destroy(Schedule $schedule)
    {
        $this->authorize('delete',$schedule);

        $this->scheduleRepository->delete($schedule);
        return Redirect::back()->with('status', 'Done');

    }

    /**
     * Display a listing of the resource for authenticated user.
     *
     * @return Factory|\Illuminate\View\View
     */
    public function userSchedule(){
        $schedules = $this->scheduleRepository->getUserSchedules();
        return view('schedules.index',compact('schedules'));
    }

}

resources/views/schedules/create.blade.php
@extends('layouts.app')

@section('content')
    <div class = "container">
        <div class = "row justify-content-center">
            <div class = "col-md-8">
                <div class = "card">
                    <div class = "card-header">{{ __('main.create') }} {{__('schedule.schedule')}}</div>

                    <div class = "card-body">
                        <form method = "POST" action = "{{ route('schedules.store')}}">
                            @csrf

                            <div class = "form-group row">
                                <label for = "title"
                                       class = "col-md-4 col-form-label text-md-right">{{ __('schedule.title') }}</label>

                                <div class = "col-md-6">
                                    <input id = "title" type = "text"
                                           class = "form-control @error('title') is-invalid @enderror" name = "title"
                                           value = "{{ old('title') }}" required autocomplete = "title" autofocus>
                                    @error('title')
                                    <span class = "invalid-feedback" role = "alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                    @enderror
                                </div>
                            </div>

                            <div class = "form-group row">
                                <label for = "start_date"
                                       class = "col-md-4 col-form-label text-md-right">{{ __('schedule.start_date') }}</label>
                                <div class = "col-md-6">
                                    <input type = "datetime-local" id = "start_date" name = "start_date" value = "{{ old('start_date') }}"
                                           class = "form-control">
                                    @error('start_date')
                                    <span class = "invalid-feedback" role = "alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                    @enderror
                                </div>
                            </div>
                            <div class = "form-group row mb-0">
                                <div class = "col-md-6 offset-md-4">
                                    <button type = "submit" class = "btn btn-primary">
                                        {{ __('main.submit') }}
                                    </button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/schedules/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class = "container">
        <div class = "row justify-content-center">
            <div class = "col-md-8">
                <div class = "card">
                    <div class = "card-header">{{ __('main.edit') }} {{__('schedule.schedule')}}</div>

                    <div class = "card-body">
                        <form method = "POST" action = "{{ route('schedules.update',$schedule)}}">
                            @csrf
                            @method('PUT')

                            <div class = "form-group row">
                                <label for = "title"
                                       class = "col-md-4 col-form-label text-md-right">{{ __('schedule.title') }}</label>

                                <div class = "col-md-6">
                                    <input id = "title" type = "text"
                                           class = "form-control @error('title') is-invalid @enderror" name = "title"
                                           value = "{{$schedule->title}}" required autocomplete = "title" autofocus>
                                    @error('title')
                                    <span class = "invalid-feedback" role = "alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                    @enderror
                                </div>
                            </div>

                            <div class = "form-group row">
                                <label for = "start_date" class = "col-md-4 col-form-label text-md-right">
                                    {{ __('schedule.start_date') }}
                                </label>
                                <div class = "col-md-6">
                                    <input type = "datetime-local" id = "start_date" name = "start_date" value = "{{$schedule->start_date}}"
                                           class = "form-control">
                                    @error('start_date')
                                    <span class = "invalid-feedback" role = "alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                    @enderror
                                </div>
                            </div>
                            <div class = "form-group row mb-0">
                                <div class = "col-md-6 offset-md-4">
                                    <button type = "submit" class = "btn btn-primary">
                                        {{ __('main.submit') }}
                                    </button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/schedules/index.blade.php
@extends('layouts.app')
@section('head')

@endsection

@section('content')


    <!-- Content Header (Page header) -->
    <section class = "content-header">
        <div class = "container-fluid">
            <div class = "row mb-2">
                <div class = "col-sm-12">
                    <ol class = "breadcrumb">
                        <li class = "breadcrumb-item"><a
                                    href = "{{route('schedules.user_schedules')}}">{{__('main.home')}}</a></li>
                        <li class = "breadcrumb-item active">{{__('schedule.schedules')}}</li>
                    </ol>
                </div>
            </div>
        </div><!-- /.container-fluid -->
    </section>

    <div class = "content">

        @can('create',\App\Models\Schedule::class)
            <div class = "container-fluid">
                <div class = "row mb-2">
                    <div class = "col-sm-12">
                        <a class = "btn btn-info" href = "{{route('schedules.create')}}">{{__('main.add_new')}}</a>
                    </div>
                </div>
            </div>
        @endcan


        @if( $schedules && $schedules->Count() > 0)
            <table id = "available_schedules" class = "table table-bordered table-striped">
                <thead>
                <tr>
                    <th>{{__('schedule.title')}}</th>
                    <th>{{__('schedule.start_date')}}</th>
                    <th>{{__('schedule.author')}}</th>
                    <th>{{__('schedule.status')}}</th>
                    @hasanyrole(\App\Actions\UserType::CONSULTANT.'|'.\App\Actions\UserType::BSA)
                    <th>{{__('schedule.action')}}</th>
                    @endhasanyrole

                </tr>
                </thead>
                <tbody>
                @foreach($schedules as $schedule)
                    <tr>
                        <td>{{$schedule->title}}</td>
                        <td>{{$schedule->start_date}}</td>
                        <td>{{$schedule->contributor->user->name}}</td>
                        <td>{{\App\Actions\ScheduleStatus::toString($schedule->status)}}</td>
                        @hasanyrole(\App\Actions\UserType::CONSULTANT.'|'.\App\Actions\UserType::BSA)
                        <td>
                            <div class="row">
                                <div class="col-sm-6">
                                    <a class="btn btn-info" href="{{route('schedules.edit',$schedule)}}">Edit</a>
                                </div>
                                <div class="col-sm-6">
                                    <form action="{{route('schedules.destroy',$schedule)}}" method="POST">
                                        @csrf
                                        @method('DELETE')
                                        <input type="submit" value="Delete" class="btn btn-danger">
                                    </form>
                                </div>
                            </div>
                        </td>
                        @endhasanyrole
                    </tr>
                @endforeach

                </tbody>
            </table>
        @else
            <div class = "container">
                <div class = "row justify-content-center">
                    <div class = "col-md-8">
                        <div class = "card">
                            <div class = "card-header">{{ __('Welcome') }}</div>

                            <div class = "card-body">
                                {{ __('messages.no_schedules_available') }}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        @endif

    </div>

@endsection

@section('extra-scripts')

    <script>
        $(document).ready(function () {
            $('#available_schedules').DataTable();
        });
    </script>

@endsection